package pg.android.activity;

import pg.android.kernel.Device;
import pg.android.kernel.DeviceContainer;
import pg.android.kernel.Protocol;
import android.app.Activity;
import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.content.IntentFilter;
import android.os.Bundle;
import android.widget.TextView;
import android.widget.Toast;

public class DeviceInfoActivity extends Activity {
	private TextView deviceNummer;
	private TextView deviceType;
	private TextView deviceSubType;
	private TextView deviceName;
	private TextView dataType;
	private TextView bitDepth;
	private TextView scale;
	private TextView minValue;
	private TextView maxValue;
	private TextView curValue;
	
	private int nummer;
	
    private final BroadcastReceiver broadcastReceiver = new BroadcastReceiver() {
		@Override
		public void onReceive(Context context, Intent intent) {
			String action = intent.getAction();
			
			if (action.equals("VALUECHANGED")) {
				
				if (nummer == intent.getExtras().getInt("DeviceNumber")) {
					Logger.add("recieve VALUECHANGED");
					Device device = DeviceContainer.get(nummer);
					if (device == null){
			        	Toast toast = Toast.makeText(getApplicationContext(), "Sensor nicht gefunden", Toast.LENGTH_SHORT);
			        	toast.show();
						finish();
					}
					
					curValue.setText(Float.toString(device.getValue()));					
				}				
			}
		}
    };
	
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		
		setContentView(R.layout.deviceactivitylayout);
		
		Bundle extras = getIntent().getExtras();
		nummer = extras.getInt("DeviceNummer");
		
		Device device = DeviceContainer.get(nummer);
		if (device == null){
        	Toast toast = Toast.makeText(getApplicationContext(), "Sensor nicht gefunden", Toast.LENGTH_SHORT);
        	toast.show();
			finish();
		}
		
		deviceNummer = (TextView)findViewById(R.id.v_number);
		deviceNummer.setText(Integer.toString(nummer));
		
		deviceType = (TextView)findViewById(R.id.v_typ);
		deviceType.setText("Sensor");

		deviceSubType = (TextView)findViewById(R.id.v_subtyp);
		deviceSubType.setText(getResources().getString(Protocol.Sensors.get(device.getSubType())));
		
		deviceName = (TextView)findViewById(R.id.v_name);
		deviceName.setText(device.name);

		dataType = (TextView)findViewById(R.id.v_datatyp);
		dataType.setText(Integer.toHexString(device.dataType & 0xFF));
		
		TextView data_type = (TextView)findViewById(R.id.v_datatyp);
		data_type.setText(Protocol.DataTypes.get(device.dataType));
		
		bitDepth = (TextView)findViewById(R.id.v_bitdepth);
		bitDepth.setText(Integer.toHexString(device.bitDepth & 0xFF));
		
		scale = (TextView)findViewById(R.id.v_scale);
		scale.setText(Integer.toHexString(device.scale & 0xFF));
		
		minValue = (TextView)findViewById(R.id.v_min);
		minValue.setText(Float.toString(device.minValue));

		maxValue = (TextView)findViewById(R.id.v_max);
		maxValue.setText(Float.toString(device.maxValue));

		curValue = (TextView)findViewById(R.id.v_cur);
		curValue.setText(Float.toString(device.getValue()));
	}
	
	
	@Override
	protected void onPause() {
		// TODO Auto-generated method stub
		super.onPause();
		unregisterReceiver(broadcastReceiver);	//BroadcastReceiver unregistrieren

	}

	@Override
	protected void onResume() {
		// TODO Auto-generated method stub
		super.onResume();
		registerReceiver(broadcastReceiver,new IntentFilter("VALUECHANGED")); 
		
	}
	
}
